package turtle;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeEvent;
import javax.swing.JPanel;
import java.awt.Graphics;
import java.awt.Insets;
import java.awt.Color;

import turtle.talk.Maze;

/** View for the maze.
 * <p>Title: Turtle-talk</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: Mmorial University</p>
 * @author Theodore Norvell
 * @version 1.0
 */

class MazePanel extends JPanel {

    Maze maze ;
    
    public MazePanel( Maze maze ) {
        this.maze = maze ;
        maze.addListener( new PropertyChangeListener() {
            public void propertyChange(PropertyChangeEvent evt) {
                repaint() ; } } ) ;
    }
    
    public void paintComponent(Graphics g) {
        int mazeHeight = maze.getHeight() ;
        int mazeWidth = maze.getWidth() ;
        Insets insets = getInsets();
        int myHeight = getHeight() - insets.top - insets.bottom;
        int myWidth = getWidth() - insets.left - insets.right;
        
        if( myWidth <= 0 || myHeight <= 0 ) return ;
        int squareSize = Math.min( myWidth/mazeWidth, myHeight/mazeHeight ) ;
        
        for(int i=0, y=insets.top ; i < mazeHeight ; i+=1, y+=squareSize ) {
            for( int j=0, x=insets.left ; j < mazeWidth ; j+=1, x+=squareSize ) {
                g.clearRect(x, y, squareSize, squareSize);
                int value = maze.get(i,j) ;
                switch( value ) {
                case Maze.TURTLE|Maze.GOAL:
                    g.setColor(Color.orange);
                    g.fillRect(x,y,squareSize,squareSize);
                    g.setColor(Color.green);
                    g.fillOval(x,y,squareSize,squareSize);
                break ;
                case Maze.TURTLE:
                    g.setColor(Color.green);
                    g.fillOval(x,y,squareSize,squareSize);
                break ;
                case Maze.WALL:
                    g.setColor(Color.black);
                    g.fillRect(x,y,squareSize,squareSize);
                break ;
                case Maze.GOAL:
                    g.setColor(Color.orange);
                    g.fillRect(x,y,squareSize,squareSize);
                default :
                    /*assert( false ) ;*/ } } }
    }   
}