/* Generated By:JavaCC: Do not edit this line. TurtleTalkParser.java */
package turtle.talk ;

class TurtleTalkParser implements TurtleTalkParserConstants {

    private CodeEmitter codeEmitter ;

    private Analyser analyser ;

    void setCodeEmitter( CodeEmitter codeEmitter ) {
        this.codeEmitter = codeEmitter ; }

    void setAnalyser( Analyser analyser ) {
        this.analyser = analyser ; }

    void analyseUnaryOp( int operandType, int resultType ) throws TurtleTalkException
    {
        analyser.check( analyser.top() == operandType,
                        "Type error" ) ;
        analyser.pop() ;
        analyser.push( resultType ) ;
    }

    void analyseBinaryOp( int leftOperandType, int rightOperandType, int resultType ) throws TurtleTalkException
    {
        analyser.check( analyser.top() == rightOperandType,
                        "Type error" ) ;
        analyser.pop() ;
        analyser.check( analyser.top() == leftOperandType,
                        "Type error" ) ;
        analyser.pop() ;
        analyser.push( resultType ) ;
    }

///////////////////////////////////////////////////////////////////
// Here begins the context free grammar
///////////////////////////////////////////////////////////////////

// Translation_Unit --> Block <EOF>
  final public void Translation_Unit() throws ParseException, TurtleTalkException {
    Block();
    jj_consume_token(0);
      codeEmitter.emitByte( OpCode.HALT ) ;
  }

  final public void Block() throws ParseException, TurtleTalkException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case GET:
    case IF:
    case PUT:
    case WHILE:
    case ID:
      Statement();
      Block();
      break;
    case VAR:
      VarBlock();
      break;
    default:
      jj_la1[0] = jj_gen;

    }
  }

  final public void VarBlock() throws ParseException, TurtleTalkException {
    SymbolTableEntry varSymbolTableEntry ;
    SymbolTableEntry previousSymbolTableEntry ;
    SymbolTableEntry typeSymbolTableEntry ;
    int varAddress ;
    jj_consume_token(VAR);
    previousSymbolTableEntry = Id();
    jj_consume_token(COLON);
    typeSymbolTableEntry = Id();
    jj_consume_token(ASSIGN);
    Expression();
      varSymbolTableEntry = analyser.startVariableScope( previousSymbolTableEntry,
                                                         typeSymbolTableEntry ) ;
      analyser.check( analyser.top() == varSymbolTableEntry.getType(), "Type mismatch" ) ;
      analyser.pop() ;
      varAddress = varSymbolTableEntry.getAddress() ;
      codeEmitter.emitPush( varAddress ) ;
      codeEmitter.emitByte( OpCode.STORE ) ;
    Block();
      analyser.endVariableScope( varSymbolTableEntry ) ;
  }

  final public void Statement() throws ParseException, TurtleTalkException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IF:
      IfStatement();
      break;
    case WHILE:
      WhileStatement();
      break;
    case PUT:
      PutStatement();
      break;
    case GET:
      GetStatement();
      break;
    case ID:
      AssignmentOrProcedureCallStatement();
      break;
    default:
      jj_la1[1] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void AssignmentOrProcedureCallStatement() throws ParseException, TurtleTalkException {
    int varAddress ;
    int numberOfArgs ;
    SymbolTableEntry symbolTableEntry ;
    CodeGenerationRule codeGenerationRule ;
    symbolTableEntry = Id();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ASSIGN:
      jj_consume_token(ASSIGN);
          analyser.check( symbolTableEntry.getKind() == SymbolTableEntry.VAR_ENTRY,
                          "Unknown Variable" ) ;
      Expression();
          analyser.check( analyser.top() == symbolTableEntry.getType(), "Type mismatch" ) ;
          analyser.pop() ;
          varAddress = symbolTableEntry.getAddress() ;
          codeEmitter.emitPush( varAddress ) ;
          codeEmitter.emitByte( OpCode.STORE ) ;
      break;
    case OPEN_PAREN:
          analyser.check( symbolTableEntry.getKind() == SymbolTableEntry.PROCEDURE_ENTRY,
                            "Unknown procedure" ) ;
      numberOfArgs = Args();
          codeGenerationRule = symbolTableEntry.getCodeGenerationRule() ;
          codeGenerationRule.apply( numberOfArgs, analyser, codeEmitter ) ;
      break;
    default:
      jj_la1[2] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void IfStatement() throws ParseException, TurtleTalkException {
    int locationOfElseAddress ;
    int locationOfEndAddress ;
    int elseAddress ;
    int endAddress ;
    jj_consume_token(IF);
    Expression();
      analyser.check( analyser.top() == Analyser.BOOL_TYPE,
                      "Expected bool in if-statement" ) ;
      analyser.pop() ;
      codeEmitter.emitByte( OpCode.PUSH16 ) ;
      locationOfElseAddress = codeEmitter.currentInstructionAddress() ;
      codeEmitter.emitInt16( 0 ) ;
      codeEmitter.emitByte( OpCode.FBRANCH ) ;
    Block();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ELSE:
      jj_consume_token(ELSE);
          codeEmitter.emitByte( OpCode.PUSH16 ) ;
          locationOfEndAddress = codeEmitter.currentInstructionAddress() ;
          codeEmitter.emitInt16( 0 ) ;
          codeEmitter.emitByte( OpCode.BRANCH ) ;
          elseAddress = codeEmitter.currentInstructionAddress() ;
      Block();
          endAddress = codeEmitter.currentInstructionAddress() ;
          codeEmitter.patchInt16( locationOfElseAddress, elseAddress ) ;
          codeEmitter.patchInt16( locationOfEndAddress, endAddress ) ;
      break;
    default:
      jj_la1[3] = jj_gen;
          elseAddress = codeEmitter.currentInstructionAddress() ;
          codeEmitter.patchInt16( locationOfElseAddress, elseAddress ) ;
    }
    jj_consume_token(END);
  }

  final public void WhileStatement() throws ParseException, TurtleTalkException {
    int startAddress ;
    int locationOfEndAddress ;
    int endAddress ;
    jj_consume_token(WHILE);
      startAddress = codeEmitter.currentInstructionAddress() ;
    Expression();
      analyser.check( analyser.top() == Analyser.BOOL_TYPE,
                      "expected bool in while-statement" ) ;
      analyser.pop() ;
      codeEmitter.emitByte( OpCode.PUSH16 ) ;
      locationOfEndAddress = codeEmitter.currentInstructionAddress() ;
      codeEmitter.emitInt16( 0 ) ;
      codeEmitter.emitByte( OpCode.FBRANCH ) ;
    Block();
    jj_consume_token(END);
      codeEmitter.emitPush( startAddress ) ;
      codeEmitter.emitByte( OpCode.BRANCH ) ;
      endAddress = codeEmitter.currentInstructionAddress() ;
      codeEmitter.patchInt16( locationOfEndAddress, endAddress ) ;
  }

  final public void PutStatement() throws ParseException, TurtleTalkException {
    Token stringToken ;
    String stringValue ;
    int stringAddress ;
    jj_consume_token(PUT);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case STRING:
      stringToken = jj_consume_token(STRING);
          stringValue = analyser.unescapeString( stringToken.image ) ;
          stringAddress = codeEmitter.putString( stringValue ) ;
          codeEmitter.emitPush( stringAddress ) ;
          codeEmitter.emitByte( OpCode.PUTSTRING ) ;
      break;
    case OPEN_PAREN:
    case MINUS:
    case NOT:
    case NUM:
    case ID:
      Expression();
          analyser.check( analyser.top() == Analyser.INT_TYPE,
                          "expected int type expression in put" ) ;
          analyser.pop() ;
          codeEmitter.emitByte( OpCode.PUTINT ) ;
      break;
    default:
      jj_la1[4] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void GetStatement() throws ParseException, TurtleTalkException {
    SymbolTableEntry symbolTableEntry ;
    int varAddress ;
    jj_consume_token(GET);
    symbolTableEntry = Id();
      analyser.check( symbolTableEntry.getKind() == SymbolTableEntry.VAR_ENTRY,
                      "Unknown variable" ) ;
      analyser.check( symbolTableEntry.getType() == Analyser.INT_TYPE,
                      "Expected int variable in get" ) ;
      codeEmitter.emitByte( OpCode.GETINT ) ;
      varAddress = symbolTableEntry.getAddress() ;
      codeEmitter.emitPush( varAddress ) ;
      codeEmitter.emitByte( OpCode.STORE ) ;
  }

  final public void Expression() throws ParseException, TurtleTalkException {
    Disjunct();
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case OR:
        ;
        break;
      default:
        jj_la1[5] = jj_gen;
        break label_1;
      }
      jj_consume_token(OR);
      Disjunct();
        analyseBinaryOp( Analyser.BOOL_TYPE, Analyser.BOOL_TYPE, Analyser.BOOL_TYPE ) ;
        codeEmitter.emitByte( OpCode.OR ) ;
    }
  }

  final public void Disjunct() throws ParseException, TurtleTalkException {
    Conjunct();
    label_2:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case AND:
        ;
        break;
      default:
        jj_la1[6] = jj_gen;
        break label_2;
      }
      jj_consume_token(AND);
      Conjunct();
        analyseBinaryOp( Analyser.BOOL_TYPE, Analyser.BOOL_TYPE, Analyser.BOOL_TYPE ) ;
        codeEmitter.emitByte( OpCode.NOT ) ;
        codeEmitter.emitByte( OpCode.FLIP ) ;
        codeEmitter.emitByte( OpCode.NOT ) ;
        codeEmitter.emitByte( OpCode.OR ) ;
        codeEmitter.emitByte( OpCode.NOT ) ;
    }
  }

  final public void Conjunct() throws ParseException, TurtleTalkException {
    RelTerm();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case EQUAL:
    case LESS:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EQUAL:
        jj_consume_token(EQUAL);
        RelTerm();
        analyseBinaryOp( Analyser.INT_TYPE, Analyser.INT_TYPE, Analyser.BOOL_TYPE ) ;
        codeEmitter.emitByte( OpCode.EQUAL ) ;
        break;
      case LESS:
        jj_consume_token(LESS);
        RelTerm();
        analyseBinaryOp( Analyser.INT_TYPE, Analyser.INT_TYPE, Analyser.BOOL_TYPE ) ;
        codeEmitter.emitByte( OpCode.LESS ) ;
        break;
      default:
        jj_la1[7] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[8] = jj_gen;
      ;
    }
  }

  final public void RelTerm() throws ParseException, TurtleTalkException {
    Term();
    label_3:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PLUS:
      case MINUS:
        ;
        break;
      default:
        jj_la1[9] = jj_gen;
        break label_3;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PLUS:
        jj_consume_token(PLUS);
        Term();
        analyseBinaryOp( Analyser.INT_TYPE, Analyser.INT_TYPE, Analyser.INT_TYPE ) ;
        codeEmitter.emitByte( OpCode.ADD ) ;
        break;
      case MINUS:
        jj_consume_token(MINUS);
        Term();
        analyseBinaryOp( Analyser.INT_TYPE, Analyser.INT_TYPE, Analyser.INT_TYPE ) ;
        codeEmitter.emitByte( OpCode.SUBTRACT ) ;
        break;
      default:
        jj_la1[10] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

  final public void Term() throws ParseException, TurtleTalkException {
    Factor();
    label_4:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STAR:
      case SLASH:
        ;
        break;
      default:
        jj_la1[11] = jj_gen;
        break label_4;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STAR:
        jj_consume_token(STAR);
        Factor();
        analyseBinaryOp( Analyser.INT_TYPE, Analyser.INT_TYPE, Analyser.INT_TYPE ) ;
        codeEmitter.emitByte( OpCode.MULTIPLY ) ;
        break;
      case SLASH:
        jj_consume_token(SLASH);
        Factor();
        analyseBinaryOp( Analyser.INT_TYPE, Analyser.INT_TYPE, Analyser.INT_TYPE ) ;
        codeEmitter.emitByte( OpCode.DIVIDE ) ;
        break;
      default:
        jj_la1[12] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

  final public void Factor() throws ParseException, TurtleTalkException {
    Token t ;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OPEN_PAREN:
      jj_consume_token(OPEN_PAREN);
      Expression();
      jj_consume_token(CLOSE_PAREN);
      break;
    case MINUS:
      jj_consume_token(MINUS);
      Factor();
      analyseUnaryOp( Analyser.INT_TYPE, Analyser.INT_TYPE ) ;
      codeEmitter.emitByte( OpCode.NEGATE ) ;
      break;
    case NOT:
      jj_consume_token(NOT);
      Factor();
      analyseUnaryOp( Analyser.BOOL_TYPE, Analyser.BOOL_TYPE ) ;
      codeEmitter.emitByte( OpCode.NOT ) ;
      break;
    case NUM:
      t = jj_consume_token(NUM);
      codeEmitter.emitPush( analyser.parseInt( t.image ) ) ;
      analyser.push( Analyser.INT_TYPE ) ;
      break;
    case ID:
      VarConstantOrFunctionCall();
      break;
    default:
      jj_la1[13] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void VarConstantOrFunctionCall() throws ParseException, TurtleTalkException {
    SymbolTableEntry symbolTableEntry ;
    CodeGenerationRule codeGenerationRule ;
    int numberOfArgs ;
    int varAddress ;
    symbolTableEntry = Id();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OPEN_PAREN:
      // Arguments follow: function call
              numberOfArgs = Args();
          analyser.check( symbolTableEntry.getKind() == SymbolTableEntry.FUNCTION_ENTRY,
                          "Unknown function" ) ;
          codeGenerationRule = symbolTableEntry.getCodeGenerationRule() ;
          codeGenerationRule.apply( numberOfArgs, analyser, codeEmitter ) ;
      break;
    default:
      jj_la1[14] = jj_gen;
          if( symbolTableEntry.getKind() == SymbolTableEntry.CONSTANT_ENTRY ) {
            codeGenerationRule = symbolTableEntry.getCodeGenerationRule() ;
            codeGenerationRule.apply( 0, analyser, codeEmitter ) ;
          } else {
            analyser.check( symbolTableEntry.getKind() == SymbolTableEntry.VAR_ENTRY,
                          "Unknown variable" ) ;
            varAddress = symbolTableEntry.getAddress() ;
            codeEmitter.emitPush( varAddress ) ;
            codeEmitter.emitByte( OpCode.FETCH ) ;
            analyser.push( symbolTableEntry.getType() ) ;
          }
    }
  }

  final public int Args() throws ParseException, TurtleTalkException {
    int numberOfArgs = 0 ;
    jj_consume_token(OPEN_PAREN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OPEN_PAREN:
    case MINUS:
    case NOT:
    case NUM:
    case ID:
      Expression();
          ++numberOfArgs ;
      label_5:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[15] = jj_gen;
          break label_5;
        }
        jj_consume_token(COMMA);
        Expression();
              ++numberOfArgs ;
      }
      break;
    default:
      jj_la1[16] = jj_gen;
      ;
    }
    jj_consume_token(CLOSE_PAREN);
      {if (true) return numberOfArgs ;}
    throw new Error("Missing return statement in function");
  }

  final public SymbolTableEntry Id() throws ParseException, TurtleTalkException {
    Token token ;
    token = jj_consume_token(ID);
      {if (true) return analyser.lookup( token.image ) ;}
    throw new Error("Missing return statement in function");
  }

  public TurtleTalkParserTokenManager token_source;
  SimpleCharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private int jj_gen;
  final private int[] jj_la1 = new int[17];
  final private int[] jj_la1_0 = {0x47300000,0x45300000,0x440,0x40000,0x58404040,0x800000,0x20000,0x1800,0x1800,0x6000,0x6000,0x18000,0x18000,0x48404040,0x40,0x200,0x48404040,};

  public TurtleTalkParser(java.io.InputStream stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new TurtleTalkParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 17; i++) jj_la1[i] = -1;
  }

  public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 17; i++) jj_la1[i] = -1;
  }

  public TurtleTalkParser(java.io.Reader stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new TurtleTalkParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 17; i++) jj_la1[i] = -1;
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 17; i++) jj_la1[i] = -1;
  }

  public TurtleTalkParser(TurtleTalkParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 17; i++) jj_la1[i] = -1;
  }

  public void ReInit(TurtleTalkParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 17; i++) jj_la1[i] = -1;
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;

  final public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[32];
    for (int i = 0; i < 32; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 17; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 32; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

    //////////////////////////////////////////////////////////
    // Add any extra methods and fields to this class here. //
    //////////////////////////////////////////////////////////

}
